// ChildView.h : interface of the CChildView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_CHILDVIEW_H__88050456_96EE_11D4_9B40_A3AF3DA7B45C__INCLUDED_)
#define AFX_CHILDVIEW_H__88050456_96EE_11D4_9B40_A3AF3DA7B45C__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/////////////////////////////////////////////////////////////////////////////
// CChildView window

class CChildView : public CWnd
{
	int m_nSelectedLine, m_nRubberLine;
	int m_nSelectedQuad, m_nRubberQuad;
	int m_nSelectedCirc, m_nRubberCirc;
	int m_nSelectedTriangle, m_nRubberTriangle;

    UINT m_nColor;
    UINT m_nWidth;
	UINT m_nStyle;
	UINT m_nTool;
	UINT m_nView;
    CPoint m_ptFrom, m_ptTo;
    CPoint m_ptTri[4];
    CObArray m_lineArray;
	CObArray m_triArray;
	CObArray m_quadArray;
	CObArray m_circArray;

    static const COLORREF crColors[8];
    static const char szFilters[];

    void InvertLine (CDC*, CPoint, CPoint);
    void InvertQuad (CDC*, CPoint, CPoint);
    void InvertCirc (CDC*, CPoint, CPoint);
    void DeleteAllLines ();

// Construction
public:
	CChildView();

// Attributes
public:

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CChildView)
	protected:
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CChildView();

	// Generated message map functions
protected:
	//{{AFX_MSG(CChildView)
	afx_msg void OnPaint();
    afx_msg void OnFileNew ();
    afx_msg void OnUpdateFileUI (CCmdUI*);
    afx_msg void OnWidth (UINT);
    afx_msg void OnUpdateWidthUI (CCmdUI*);
    afx_msg void OnColor (UINT);
    afx_msg void OnUpdateColorUI (CCmdUI*);
	afx_msg void OnView (UINT);
	afx_msg void OnUpdateViewUI (CCmdUI*);
	afx_msg void OnStyle (UINT);
	afx_msg void OnUpdateStyleUI (CCmdUI*);
	afx_msg void OnTool (UINT);
	afx_msg void OnUpdateToolUI (CCmdUI*);
    afx_msg void OnLButtonDown (UINT, CPoint);
    afx_msg void OnMouseMove (UINT, CPoint);
    afx_msg void OnLButtonUp (UINT, CPoint);
public:
    afx_msg void OnMeasureItem (int, LPMEASUREITEMSTRUCT);
    afx_msg void OnDrawItem (int, LPDRAWITEMSTRUCT);
protected:
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_CHILDVIEW_H__88050456_96EE_11D4_9B40_A3AF3DA7B45C__INCLUDED_)
