// HPaint.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "HPaint.h"

#include "MainFrm.h"
#include <math.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CHPaintApp

BEGIN_MESSAGE_MAP(CHPaintApp, CWinApp)
	//{{AFX_MSG_MAP(CHPaintApp)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CHPaintApp construction

CHPaintApp::CHPaintApp()
{
}

/////////////////////////////////////////////////////////////////////////////
// CHPaintApp initialization

BOOL CHPaintApp::InitInstance()
{
	// Standard initialization

#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif

	// Change the registry key under which our settings are stored.
	SetRegistryKey(_T("Local AppWizard-Generated Applications"));



	CMainFrame* pFrame = new CMainFrame;
	m_pMainWnd = pFrame;

	// create and load the frame with its resources

	pFrame->LoadFrame(IDR_MAINFRAME,
		WS_OVERLAPPEDWINDOW | FWS_ADDTOTITLE, NULL,
		NULL);



	pFrame->ShowWindow(SW_SHOW);
	pFrame->UpdateWindow();

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////
// CLine member functions

IMPLEMENT_SERIAL (CLine, CObject, 1)

CLine::CLine (CPoint ptFrom, CPoint ptTo, UINT nWidth, UINT nStyle, COLORREF crColor)
{
    m_ptFrom = ptFrom;
    m_ptTo = ptTo;
    m_nWidth = nWidth;
	m_nStyle = nStyle;
    m_crColor = crColor;
	angle = 0.0;
}

void CLine::Serialize (CArchive& ar)
{
    CObject::Serialize (ar);

    if (ar.IsStoring ())
        ar << m_ptFrom << m_ptTo << m_nWidth << m_nStyle << (DWORD) m_crColor;
    else
        ar >> m_ptFrom >> m_ptTo >> m_nWidth >> m_nStyle >> (DWORD) m_crColor;
}

void CLine::Draw (CDC* pDC)
{
    CPen pen (m_nStyle, m_nWidth, m_crColor);

    CPen* pOldPen = pDC->SelectObject (&pen);

	CPoint a, b;
	RotateLine(a, b);

    pDC->MoveTo (a);
    pDC->LineTo (b);

    pDC->SelectObject (pOldPen);
}

void CLine::RotateLine(CPoint &a, CPoint &b)
{
	a = m_ptFrom;
	b = m_ptTo;

	CPoint center;
	center.x = (a.x + b.x)/2;
	center.y = (a.y + b.y)/2;

	// Translate to origin
	a -= center;
	b -= center;

	// Rotate
	float ax = cos(angle)*a.x - sin(angle)*a.y;
	float ay = sin(angle)*a.x + cos(angle)*a.y;

	float bx = cos(angle)*b.x - sin(angle)*b.y;
	float by = sin(angle)*b.x + cos(angle)*b.y;

	// Translate back
	a.x = ax + center.x;
	a.y = ay + center.y;
	b.x = bx + center.x;
	b.y = by + center.y;
}

void CLine::RotateDef()
{
	CPoint center;
	center.x = (m_ptFrom.x + m_ptTo.x)/2;
	center.y = (m_ptFrom.y + m_ptTo.y)/2;

	// Translate to origin
	m_ptFrom -= center;
	m_ptTo -= center;

	// Rotate
	float ax = cos(angle)*m_ptFrom.x - sin(angle)*m_ptFrom.y;
	float ay = sin(angle)*m_ptFrom.x + cos(angle)*m_ptFrom.y;

	float bx = cos(angle)*m_ptTo.x - sin(angle)*m_ptTo.y;
	float by = sin(angle)*m_ptTo.x + cos(angle)*m_ptTo.y;

	// Translate back
	m_ptFrom.x = ax + center.x;
	m_ptFrom.y = ay + center.y;
	m_ptTo.x = bx + center.x;
	m_ptTo.y = by + center.y;
}

void CLine::DrawEndsW (CDC* pDC)
{
    CPen pen (PS_SOLID, 0, RGB (0, 0, 0));

    CPen* pOldPen = pDC->SelectObject (&pen);
	pDC->SetBkColor(RGB(255,255,255));

	CPoint a, b;
	RotateLine(a, b);

	pDC->Rectangle(a.x-5, a.y-5, a.x+5, a.y+5);
	pDC->Rectangle(b.x-5, b.y-5, b.x+5, b.y+5);

    pDC->SelectObject (pOldPen);
}

void CLine::DrawEndsB (CDC* pDC)
{
    CPen pen (PS_SOLID, 0, RGB (255, 255, 255));
	CBrush brush(RGB(0,0,0));

    CPen* pOldPen = pDC->SelectObject (&pen);
	CBrush* pOldBrush = pDC->SelectObject (&brush);

	CPoint a, b;
	RotateLine(a, b);

	pDC->Rectangle(a.x-5, a.y-5, a.x+5, a.y+5);
	pDC->Rectangle(b.x-5, b.y-5, b.x+5, b.y+5);

    pDC->SelectObject (pOldBrush);
	pDC->SelectObject (pOldPen);
}

void CLine::DrawEndsBC (CDC* pDC)
{
    CPen pen (PS_SOLID, 0, RGB (255, 255, 255));
	CBrush brush(RGB(0,0,0));

    CPen* pOldPen = pDC->SelectObject (&pen);
	CBrush* pOldBrush = pDC->SelectObject (&brush);

	CPoint a, b;
	RotateLine(a, b);

	pDC->Ellipse(a.x-5, a.y-5, a.x+5, a.y+5);
	pDC->Ellipse(b.x-5, b.y-5, b.x+5, b.y+5);

    pDC->SelectObject (pOldBrush);
	pDC->SelectObject (pOldPen);
}

void CLine::DrawEndsWC (CDC* pDC)
{
    CPen pen (PS_SOLID, 0, RGB (0, 0, 0));
	CBrush brush(RGB(0,255,0));

    CPen* pOldPen = pDC->SelectObject (&pen);
	CBrush* pOldBrush = pDC->SelectObject (&brush);

	CPoint a, b;
	RotateLine(a, b);

	pDC->Ellipse(a.x-5, a.y-5, a.x+5, a.y+5);
	pDC->Ellipse(b.x-5, b.y-5, b.x+5, b.y+5);

    pDC->SelectObject (pOldBrush);
    pDC->SelectObject (pOldPen);
}

/////////////////////////////////////////////////////////////////////////
// CTri member functions

IMPLEMENT_SERIAL (CTri, CObject, 1)

CTri::CTri (CPoint pt1, CPoint pt2, CPoint pt3, UINT nWidth, UINT nStyle, 
			COLORREF crColor)
{
    m_pt[0] = pt1;
    m_pt[1] = pt2;
	m_pt[2] = pt3;
    m_nWidth = nWidth;
	m_nStyle = nStyle;
    m_crColor = crColor;
	angle = 0.0;
}

void CTri::Serialize (CArchive& ar)
{
    CObject::Serialize (ar);

    if (ar.IsStoring ())
        ar << m_pt[0] << m_pt[1] << m_pt[2] << m_nWidth << m_nStyle << (DWORD) m_crColor;
    else
        ar >> m_pt[0] >> m_pt[1] >> m_pt[2] >> m_nWidth >> m_nStyle >> (DWORD) m_crColor;
}

void CTri::RotateTri(CPoint &a, CPoint &b, CPoint &c)
{
	a = m_pt[0];
	b = m_pt[1];
	c = m_pt[2];

	CPoint center;
	center.x = (a.x + b.x + c.x)/3;
	center.y = (a.y + b.y + c.y)/3;

	// Translate to origin
	a -= center;
	b -= center;
	c -= center;

	// Rotate
	float ax = cos(angle)*a.x - sin(angle)*a.y;
	float ay = sin(angle)*a.x + cos(angle)*a.y;

	float bx = cos(angle)*b.x - sin(angle)*b.y;
	float by = sin(angle)*b.x + cos(angle)*b.y;

	float cx = cos(angle)*c.x - sin(angle)*c.y;
	float cy = sin(angle)*c.x + cos(angle)*c.y;

	// Translate back
	a.x = ax + center.x;
	a.y = ay + center.y;
	b.x = bx + center.x;
	b.y = by + center.y;
	c.x = cx + center.x;
	c.y = cy + center.y;
}

void CTri::RotateDef()
{
	CPoint center;
	center.x = (m_pt[0].x + m_pt[1].x + m_pt[2].x)/3;
	center.y = (m_pt[0].y + m_pt[1].y + m_pt[2].y)/3;

	// Translate to origin
	m_pt[0] -= center;
	m_pt[1] -= center;
	m_pt[2] -= center;

	// Rotate
	float ax = cos(angle)*m_pt[0].x - sin(angle)*m_pt[0].y;
	float ay = sin(angle)*m_pt[0].x + cos(angle)*m_pt[0].y;

	float bx = cos(angle)*m_pt[1].x - sin(angle)*m_pt[1].y;
	float by = sin(angle)*m_pt[1].x + cos(angle)*m_pt[1].y;

	float cx = cos(angle)*m_pt[2].x - sin(angle)*m_pt[2].y;
	float cy = sin(angle)*m_pt[2].x + cos(angle)*m_pt[2].y;

	// Translate back
	m_pt[0].x = ax + center.x;
	m_pt[0].y = ay + center.y;
	m_pt[1].x = bx + center.x;
	m_pt[1].y = by + center.y;
	m_pt[2].x = cx + center.x;
	m_pt[2].y = cy + center.y;
}

void CTri::Draw (CDC* pDC)
{
    CPen pen (m_nStyle, m_nWidth, m_crColor);

    CPen* pOldPen = pDC->SelectObject (&pen);
    pDC->MoveTo (m_pt[0]);
    pDC->LineTo (m_pt[1]);

    pDC->MoveTo (m_pt[1]);
    pDC->LineTo (m_pt[2]);

    pDC->MoveTo (m_pt[2]);
    pDC->LineTo (m_pt[0]);

    pDC->SelectObject (pOldPen);
}

void CTri::DrawEndsW (CDC* pDC)
{
    CPen pen (PS_SOLID, 0, RGB (0, 0, 0));

    CPen* pOldPen = pDC->SelectObject (&pen);

	pDC->Rectangle(m_pt[0].x-5, m_pt[0].y-5, m_pt[0].x+5, m_pt[0].y+5);
	pDC->Rectangle(m_pt[1].x-5, m_pt[1].y-5, m_pt[1].x+5, m_pt[1].y+5);
	pDC->Rectangle(m_pt[2].x-5, m_pt[2].y-5, m_pt[2].x+5, m_pt[2].y+5);

    pDC->SelectObject (pOldPen);
}

void CTri::DrawEndsB (CDC* pDC)
{
    CPen pen (PS_SOLID, 0, RGB (255, 255, 255));
	CBrush brush(RGB(0,0,0));

    CPen* pOldPen = pDC->SelectObject (&pen);
	CBrush* pOldBrush = pDC->SelectObject (&brush);

	pDC->Rectangle(m_pt[0].x-5, m_pt[0].y-5, m_pt[0].x+5, m_pt[0].y+5);
	pDC->Rectangle(m_pt[1].x-5, m_pt[1].y-5, m_pt[1].x+5, m_pt[1].y+5);
	pDC->Rectangle(m_pt[2].x-5, m_pt[2].y-5, m_pt[2].x+5, m_pt[2].y+5);

    pDC->SelectObject (pOldBrush);
	pDC->SelectObject (pOldPen);
}

void CTri::DrawEndsWC (CDC* pDC)
{
    CPen pen (PS_SOLID, 0, RGB (0, 0, 0));
	CBrush brush(RGB(0,255,0));

    CPen* pOldPen = pDC->SelectObject (&pen);
	CBrush* pOldBrush = pDC->SelectObject (&brush);

	pDC->Ellipse(m_pt[0].x-5, m_pt[0].y-5, m_pt[0].x+5, m_pt[0].y+5);
	pDC->Ellipse(m_pt[1].x-5, m_pt[1].y-5, m_pt[1].x+5, m_pt[1].y+5);
	pDC->Ellipse(m_pt[2].x-5, m_pt[2].y-5, m_pt[2].x+5, m_pt[2].y+5);

    pDC->SelectObject (pOldBrush);
	pDC->SelectObject (pOldPen);
}

void CTri::DrawEndsBC (CDC* pDC)
{
    CPen pen (PS_SOLID, 0, RGB (255, 255, 255));
	CBrush brush(RGB(0,0,0));

    CPen* pOldPen = pDC->SelectObject (&pen);
	CBrush* pOldBrush = pDC->SelectObject (&brush);

	pDC->Ellipse(m_pt[0].x-5, m_pt[0].y-5, m_pt[0].x+5, m_pt[0].y+5);
	pDC->Ellipse(m_pt[1].x-5, m_pt[1].y-5, m_pt[1].x+5, m_pt[1].y+5);
	pDC->Ellipse(m_pt[2].x-5, m_pt[2].y-5, m_pt[2].x+5, m_pt[2].y+5);

    pDC->SelectObject (pOldBrush);
	pDC->SelectObject (pOldPen);
}

/////////////////////////////////////////////////////////////////////////
// CQuad member functions

IMPLEMENT_SERIAL (CQuad, CObject, 1)

CQuad::CQuad (CPoint ptFrom, CPoint ptTo, UINT nWidth, UINT nStyle, COLORREF crColor)
{
    m_ptFrom = ptFrom;
    m_ptTo = ptTo;
	
	m_nWidth = nWidth;
	m_nStyle = nStyle;
    m_crColor = crColor;
}

void CQuad::Serialize (CArchive& ar)
{
    CObject::Serialize (ar);

    if (ar.IsStoring ())
        ar << m_ptFrom << m_ptTo << m_nWidth << m_nStyle << (DWORD) m_crColor;
    else
        ar >> m_ptFrom >> m_ptTo >> m_nWidth >> m_nStyle >> (DWORD) m_crColor;
}

void CQuad::Draw (CDC* pDC)
{
    CPen pen (m_nStyle, m_nWidth, m_crColor);

    CPen* pOldPen = pDC->SelectObject (&pen);
    
    pDC->MoveTo (m_ptFrom);
    pDC->LineTo (m_ptTo.x, m_ptFrom.y);

    pDC->MoveTo (m_ptTo.x, m_ptFrom.y);
    pDC->LineTo (m_ptTo);

    pDC->MoveTo (m_ptTo);
    pDC->LineTo (m_ptFrom.x, m_ptTo.y);

	pDC->MoveTo (m_ptFrom.x, m_ptTo.y);
	pDC->LineTo (m_ptFrom);
	
    pDC->SelectObject (pOldPen);
}

void CQuad::DrawEndsW (CDC* pDC)
{
    CPen pen (PS_SOLID, 0, RGB (0, 0, 0));

    CPen* pOldPen = pDC->SelectObject (&pen);

	pDC->Rectangle(m_ptFrom.x-5, m_ptFrom.y-5, m_ptFrom.x+5, m_ptFrom.y+5);
	pDC->Rectangle(m_ptTo.x-5, m_ptTo.y-5, m_ptTo.x+5, m_ptTo.y+5);

    pDC->SelectObject (pOldPen);
}

void CQuad::DrawEndsB (CDC* pDC)
{
    CPen pen (PS_SOLID, 0, RGB (255, 255, 255));
	CBrush brush(RGB(0,0,0));

    CPen* pOldPen = pDC->SelectObject (&pen);
	CBrush* pOldBrush = pDC->SelectObject (&brush);

	pDC->Rectangle(m_ptFrom.x-5, m_ptFrom.y-5, m_ptFrom.x+5, m_ptFrom.y+5);
	pDC->Rectangle(m_ptTo.x-5, m_ptTo.y-5, m_ptTo.x+5, m_ptTo.y+5);

    pDC->SelectObject (pOldBrush);
	pDC->SelectObject (pOldPen);
}

/////////////////////////////////////////////////////////////////////////
// CCirc member functions

IMPLEMENT_SERIAL (CCirc, CObject, 1)

CCirc::CCirc (CPoint ptFrom, CPoint ptTo, UINT nWidth, UINT nStyle, COLORREF crColor)
{
    m_ptFrom = ptFrom;
    m_ptTo = ptTo;
    m_nWidth = nWidth;
	m_nStyle = nStyle;
    m_crColor = crColor;
}

void CCirc::Serialize (CArchive& ar)
{
    CObject::Serialize (ar);

    if (ar.IsStoring ())
        ar << m_ptFrom << m_ptTo << m_nWidth << m_nStyle << (DWORD) m_crColor;
    else
        ar >> m_ptFrom >> m_ptTo >> m_nWidth >> m_nStyle >> (DWORD) m_crColor;
}

void CCirc::Draw (CDC* pDC)
{
    CPen pen (m_nStyle, m_nWidth, m_crColor);
	CPen* pOldPen = pDC->SelectObject (&pen);

	float L = (float)m_ptFrom.x;
	float T = (float)m_ptFrom.y;
	float R = (float)m_ptTo.x;
	float B = (float)m_ptTo.y;
	float Xc = (L+R)/2;
	float Yc = (T+B)/2;
	float radius = (B-T)/2;

	CPoint pt;
	pt.x = Xc+radius;
	pt.y = Yc;

	for(float t = .025; t <= 1.025; t += .025)
	{
		pDC->MoveTo(pt.x, pt.y);
		pt.x = Xc+radius*cos(2*PI*t);
		pt.y = Yc+radius*sin(2*PI*t);
		pDC->LineTo(pt.x, pt.y);
	}
	
	pDC->SelectObject (pOldPen);
}

void CCirc::DrawEndsW (CDC* pDC)
{
    CPen pen (PS_SOLID, 0, RGB (0, 0, 0));

    CPen* pOldPen = pDC->SelectObject (&pen);
	pDC->SetBkColor(RGB(255,255,255));

	pDC->Rectangle(m_ptFrom.x-5, m_ptFrom.y-5, m_ptFrom.x+5, m_ptFrom.y+5);
	pDC->Rectangle(m_ptTo.x-5, m_ptTo.y-5, m_ptTo.x+5, m_ptTo.y+5);

    pDC->SelectObject (pOldPen);
}

void CCirc::DrawEndsB (CDC* pDC)
{
    CPen pen (PS_SOLID, 0, RGB (255, 255, 255));
	CBrush brush(RGB(0,0,0));

    CPen* pOldPen = pDC->SelectObject (&pen);
	CBrush* pOldBrush = pDC->SelectObject (&brush);

	pDC->Rectangle(m_ptFrom.x-5, m_ptFrom.y-5, m_ptFrom.x+5, m_ptFrom.y+5);
	pDC->Rectangle(m_ptTo.x-5, m_ptTo.y-5, m_ptTo.x+5, m_ptTo.y+5);

    pDC->SelectObject (pOldBrush);
	pDC->SelectObject (pOldPen);
}
