// HPaint.h : main header file for the HPAINT application
//

#if !defined(AFX_HPAINT_H__88050450_96EE_11D4_9B40_A3AF3DA7B45C__INCLUDED_)
#define AFX_HPAINT_H__88050450_96EE_11D4_9B40_A3AF3DA7B45C__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#ifndef __AFXWIN_H__
	#error include 'stdafx.h' before including this file for PCH
#endif


#define OEMRESOURCE
#include "resource.h"       // main symbols

#define PI 3.1415926535897932384626433832795

/////////////////////////////////////////////////////////////////////////////
// CLine:
// See HPaint.cpp for the implementation of this class
//

class CLine : public CObject
{
    DECLARE_SERIAL (CLine)

public:
    CPoint m_ptFrom;
    CPoint m_ptTo;
    UINT m_nWidth;
	UINT m_nStyle;
    COLORREF m_crColor;
	float angle;

    CLine () {}
    CLine (CPoint, CPoint, UINT, UINT, COLORREF);
    virtual void Serialize (CArchive&);
    virtual void Draw (CDC*);
	virtual void RotateLine(CPoint &a, CPoint &b);
	virtual void RotateDef();
	virtual void DrawEndsW (CDC* pDC);
	virtual void DrawEndsB (CDC* pDC);
	virtual void DrawEndsWC (CDC* pDC);
	virtual void DrawEndsBC (CDC* pDC);
};

/////////////////////////////////////////////////////////////////////////////
// CTri:
// See HPaint.cpp for the implementation of this class
//

class CTri : public CObject
{
    DECLARE_SERIAL (CTri)

public:
    CPoint m_pt[3];
    UINT m_nWidth;
	UINT m_nStyle;
    COLORREF m_crColor;
	float angle;

    CTri () {}
    CTri (CPoint, CPoint, CPoint, UINT, UINT, COLORREF);
    virtual void Serialize (CArchive&);
    virtual void Draw (CDC*);
	virtual void RotateTri(CPoint &a, CPoint &b, CPoint &c);
	virtual void RotateDef();
	virtual void DrawEndsW (CDC* pDC);
	virtual void DrawEndsB (CDC* pDC);
	virtual void DrawEndsWC (CDC* pDC);
	virtual void DrawEndsBC (CDC* pDC);
};

/////////////////////////////////////////////////////////////////////////////
// CQuad:
// See HPaint.cpp for the implementation of this class
//

class CQuad : public CObject
{
    DECLARE_SERIAL (CQuad)

public:
    CPoint m_ptFrom, m_ptTo;
    UINT m_nWidth;
	UINT m_nStyle;
    COLORREF m_crColor;

    CQuad () {}
    CQuad (CPoint, CPoint, UINT, UINT, COLORREF);
    virtual void Serialize (CArchive&);
    virtual void Draw (CDC*);
	virtual void DrawEndsW (CDC* pDC);
	virtual void DrawEndsB (CDC* pDC);
};

/////////////////////////////////////////////////////////////////////////////
// CCirc:
// See HPaint.cpp for the implementation of this class
//

class CCirc : public CObject
{
    DECLARE_SERIAL (CCirc)

public:
    CPoint m_ptFrom, m_ptTo;
    UINT m_nWidth;
	UINT m_nStyle;
    COLORREF m_crColor;

    CCirc () {}
    CCirc (CPoint, CPoint, UINT, UINT, COLORREF);
    virtual void Serialize (CArchive&);
    virtual void Draw (CDC*);
	virtual void DrawEndsW (CDC* pDC);
	virtual void DrawEndsB (CDC* pDC);
};

/////////////////////////////////////////////////////////////////////////////
// CHPaintApp:
// See HPaint.cpp for the implementation of this class
//

class CHPaintApp : public CWinApp
{
public:
	CHPaintApp();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CHPaintApp)
	public:
	virtual BOOL InitInstance();
	//}}AFX_VIRTUAL

// Implementation

public:
	//{{AFX_MSG(CHPaintApp)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};


/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_HPAINT_H__88050450_96EE_11D4_9B40_A3AF3DA7B45C__INCLUDED_)
